﻿using System;
using System.Collections.Generic;
using System.Windows.Forms;
using Infragistics.Win;
using Infragistics.Win.UltraWinEditors;
using Infragistics.Win.UltraWinGrid;

namespace GridTest1
{
    public partial class Form1 : Form
    {
        private List<DummyDataItem> _testdata;

        public Form1()
        {
            InitializeComponent();

            this.ultraGrid1.DisplayLayout.GroupByBox.Style = GroupByBoxStyle.Compact;
            this.Load += new EventHandler(Form_Load);
            this.ultraGrid1.InitializeRow += new InitializeRowEventHandler(ultraGrid1_InitializeRow);
            this.ultraGrid1.CellChange += new CellEventHandler(ultraGrid1_CellChange);
        }
        
        void Form_Load(object sender, EventArgs e)
        {
            _testdata = new List<DummyDataItem>();

            _testdata.Add(new DummyDataItem("Houston", "nice place", "TX"));
            _testdata.Add(new DummyDataItem("Chicago", "little windy", "IL"));
            _testdata.Add(new DummyDataItem("Miami", "warm and sunny", "FL"));

            ultraGrid1.DataSource = _testdata;
        }

        void ultraGrid1_InitializeRow(object sender, InitializeRowEventArgs e)
        {
            if (!e.ReInitialize)
            {
                ValueList vl = new ValueList();

                vl.ValueListItems.Add(new ValueListItem(new DummyComboObject("Alaska"), "AK"));
                vl.ValueListItems.Add(new ValueListItem(new DummyComboObject("Ohio"), "OH"));
                vl.ValueListItems.Add(new ValueListItem(new DummyComboObject("Virginia"), "VA"));
                vl.ValueListItems.Add(new ValueListItem(new DummyComboObject("Illinois"), "IL"));
                vl.ValueListItems.Add(new ValueListItem(new DummyComboObject("Georgia"), "GA"));
                vl.ValueListItems.Add(new ValueListItem(new DummyComboObject("Texas"), "TX"));
                vl.ValueListItems.Add(new ValueListItem(new DummyComboObject("Florida"), "FL"));
                vl.ValueListItems.Add(new ValueListItem(new DummyComboObject("Michigan"), "MI"));
                vl.ValueListItems.Add(new ValueListItem(new DummyComboObject("Utah"), "UT"));

                e.Row.Cells[2].ValueList = vl;
                e.Row.Cells[2].Style = Infragistics.Win.UltraWinGrid.ColumnStyle.DropDownList;

                e.Row.Band.Columns[2].ButtonDisplayStyle = Infragistics.Win.UltraWinGrid.ButtonDisplayStyle.Always;

                EditorWithCombo edit = e.Row.Cells[2].EditorResolved as EditorWithCombo;
                edit.SelectionChangeCommitted += new EventHandler(edit_SelectionChangeCommitted);
            }
        }

        void ultraGrid1_CellChange(object sender, CellEventArgs e)
        {
            if (e.Cell.Column.Key == "CityState")
            {
                this.ultraGrid1.BeginUpdate();
                EditorWithCombo cellEdit = (EditorWithCombo) e.Cell.EditorResolved;

                if (cellEdit.HasButtonsLeft)
                {
                    foreach (EditorButton button in cellEdit.ButtonsLeft)
                    {
                        button.Click -= btnDummy_Click;
                    }
                    cellEdit.ButtonsLeft.Clear();
                }
                
                EditorButton newButton = new EditorButton();
                newButton.Click += new EditorButtonEventHandler(btnDummy_Click);
                cellEdit.ButtonsLeft.Add(newButton);

                this.ultraGrid1.EndUpdate();

                e.Cell.Row.Refresh(RefreshRow.RefreshDisplay);
            }
        }

        void btnDummy_Click(object sender, EditorButtonEventArgs e)
        {
            MessageBox.Show("button will be removed");

            UltraGridCell cell = e.Context as UltraGridCell;
            EditorWithCombo edit = cell.EditorResolved as EditorWithCombo;

            this.ultraGrid1.BeginUpdate();
            edit.ButtonsLeft.Clear();
            this.ultraGrid1.EndUpdate();
        }

        void edit_SelectionChangeCommitted(object sender, EventArgs e)
        {
            EditorWithCombo edit = sender as EditorWithCombo;
            DummyComboObject selected = edit.ValueList.GetValue(edit.ValueList.SelectedItemIndex) as DummyComboObject;

            label2.Text = selected.Description;
        }

    }
}
